/*
 * parallel ausgefuehrt??? "gzip -c1 -" als filter!
 * teste fork,popen,system auf Speicherverbrauch!
 *
 */
#if 0
#define PSC "ps -Twvf"  /* ps -V 2.0.2 ps-tree */
#else
#define PSC "ps -fw" /* thor */ 
#endif

#include <stdio.h>
#include <stdlib.h>
#include <fcntl.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <sys/time.h>
#include <sys/wait.h>
#include <unistd.h>
#include <signal.h>
#include <string.h>
#include <malloc.h>
#define ERR(no)  { printf("\nDEBUG: "__FILE__" L%d: %d\n",__LINE__,no); }
#define EE()		{printf("\n%s L%d: ",__FILE__,__LINE__);fflush(stdout);}
#define E0(s1)		{EE();printf("error "s1);fflush(stdout);}
#define E1(s1,a1)	{EE();printf("error "s1,a1);fflush(stdout);}
#define E2(s1,a1,a2)	{EE();printf("error "s1,a1,a2);fflush(stdout);}
#define E3(s1,a1,a2,a3)	{EE();printf("error "s1,a1,a2,a3);fflush(stdout);}
#define FE()		{printf("\n");exit(1); }
#define F0(s1)		{EE();printf("fatal "s1);FE();}
#define F1(s1,a1)	{EE();printf("fatal "s1,a1);FE();}
#define F2(s1,a1,a2)	{EE();printf("fatal "s1,a1,a2);FE();}
#define F3(s1,a1,a2,a3)	{EE();printf("fatal "s1,a1,a2,a3);FE();}

#ifdef _AIX
#include <sys/select.h>
#include <strings.h>
#endif

int test_fork(){
    int i,childpid;
    childpid = fork();
    for(i=0;i<4 && childpid==-1;i++){ /* sometimes challenge do not fork, why??? */
      E0("fork, try again after sleep(10)");
      sleep(10); childpid = fork();
    }
    switch(childpid)
    {
      case -1: perror("fork failed");E0("fork failed");break;
      case 0: printf(" fork succesfull ..\n");fflush(stdout);
       system(PSC";echo fork was succesfull");
       /* execlp("gzip","gzip","-fcd","-", NULL);  argv[1]=name */
             exit(0);break;
    }
    
    return 0;
}

int test_popen(){
    char s[100];int i;FILE *fn;
    sprintf(s,PSC);
    for(i=0,fn=NULL;i<4 && fn==NULL;i++){
      fn=popen(s,"w");
      if (!fn) { perror("popen_error");
                 E1("pipe_wopen %s",s);
                 system(PSC); sleep(10); }
    }
    if(fn)printf("popen was succesfull\n");fflush(stdout);
    system(PSC);
    if(fn) pclose(fn);
    return 0;
}

int buf[1024*1024];
int main(int argc, char *argv[])
{       char *s;
        unsigned long int num,i;
        if(argc!=2)F0(" no arg given (memory in MB)");
        num=atol(argv[1]);
        printf(" %luMB=%luB size_t=%d => %lu\n",
         num,num*1024*1024,sizeof(size_t),
          (unsigned long)(size_t)num*1024*1024);fflush(stdout);
        s=(char *)malloc((size_t)num*1024*1024);
        if(s==NULL)F0("malloc failed");fflush(stdout);
        for(i=0;i<10*1024;i++)s[(num*1024*1024/(1024*10))*i]=i;
        s[100]=0;buf[0]=buf[1024*1023]=1;
        test_popen();			/* gzip */
        test_fork();fflush(stdout);

}
